if(typeof window.IDTP === 'undefined') {(function(){ //begin definition

	//Constants
	var state_init = 0;
	var state_reading = 1;
	var hex = 6;

	//Constructor
	IDTP = function(idSource, data, callbackFn)
	{
		this.qID = 'key'+Math.floor(Math.random()*100000000);
		this.callWhenDone = callbackFn;
		this.input = data;

		this.state = state_init;

		this.bitArray = new Array(hex);
		this.bitCounter = 0;
		this.hextetCounter = 0;

		this.answer64 = '';
		this.answer = undefined;
		this.answerLength = undefined;


		//prep datastring
		var dQ = [];
		for(var propName in data)
			dQ.push('data['+encodeURIComponent(propName)+']='+encodeURIComponent(data[propName]));
		dQ = dQ.join('&');

		//prep base URL
		var joiner = idSource.indexOf('?') === -1 ? '?' : '&';
		this.baseURL = idSource + joiner + 'qID=' + this.qID;


		//prep portal
		this.portal = document.body.insertBefore(document.createElement('img'), null);
		var me = this;

		this.portal.onload = function()
		{
			me.portal.onload = function()// reassign to real portal reader
			{
				me.portalRead.apply(me, arguments);
			};
			//open portal
			me.portal.src = me.baseURL + '&' + dQ; // this will trigger the portalRead callback
			// ...see you on the other side!

			//END CLOSURE
		}; this.portal.src = 'waiting.gif'; // trigger
	};

	//Static methods
	IDTP.ask = function(source, data, callback)
	{
		//instance-ify and start
		return new IDTP(source, data, callback);
	};

	//Instance members
	IDTP.prototype =
	{
		portalRead:function()
		{
			if(this.state === state_reading)
			{
				this.bitArray[this.bitCounter++] = this.portal.width-1;
				this.bitArray[this.bitCounter++] = this.portal.height-1;

				if(this.bitCounter === hex)
				{
					this.bitCounter = 0;
					this.hextetCounter++;
					this.answer64 += OsterMiller.hextet_to_c64(this.bitArray);
				}

				if(this.hextetCounter === this.answerLength)
				{
					this.finish();
					return;
				}

				this.readNext();
			}
			else if(this.state === state_init)
			{
				this.answerLength = this.portal.width;
				if(this.answerLength === 0)
				{
					this.answer = '';
					this.finish();
					return;
				}

				this.state = state_reading;
				this.readNext();
			}
		},

		readNext:function()
		{
			this.portal.src = this.baseURL + '&hextetOffset='+this.hextetCounter+'&bitOffset='+this.bitCounter;
			//wait for load callback
		},

		finish:function()
		{
			this.answer = OsterMiller.decodeBase64(this.answer64);
			this.portal.parentNode.removeChild(this.portal);
			this.callWhenDone();
		}
	};

})()} //end definition